#define TRY_WRITE
#define TRY_READ

dim fsrw as class using "fsrw.spin"

const D0=22, CLK=23, DI=24, CS=25

sub openfile(n as integer, name as string, mode as string)
  dim r
  r = fsrw.popen(name, asc(mode))
  if r < 0 then
    throw r
  end if
  open SendRecvDevice(@fsrw.pputc, @fsrw.pgetc, @fsrw.pclose) as #n
end sub

dim err
dim s$
dim cycles as uinteger
dim c as integer

try

  fsrw.mount_explicit(D0, CLK, DI, CS)
  print "done mount"

#ifdef TRY_WRITE
  pausems 500
  print "testing write"
  openfile(2, "hello.txt", "w")
  print #2, "Hello from basdemo.bas"
  cycles = getcnt()
  print #2, "When this was written, cycles = "; cycles
  print #2, "Goodbye!"
  close #2
#endif
#ifdef TRY_READ
  pausems 1000
  ' try reading it back
  print "testing read"
  openfile(2, "hello.txt", "r")
  print ".. input"
  s$ = input$(80, 2)
  if s$ then
    print "read back:"
    print s$
  else
    print "got end of file"
  endif
  close #2
#endif
  print "all done"

catch err

print "caught error: "; err

end try
